--=================================================================================
-- Skyline Lua dynamic character with key/mouse/joystick control
-- 2015 Requires Skyline Version 0.9.4 or greater
--=================================================================================

--[[HeaderImage|Character_Player_Melee_DynamicProperty_header.png]]
--[[Prop|button]] Update_Values = "Update" 

---------------------------------------------------------------------------------
-- EDITOR: PHYSICS
---------------------------------------------------------------------------------
--[[Prop|Header]]   Character_Size 		= "" 
--[[Prop|float]]	Character_Height 	= 1.6
--[[Prop|float]]	Character_Offset 	= -1.35
--[[Prop|float]]	Character_Width 	= 0.4


---------------------------------------------------------------------------------
-- EDITOR: SPEED
---------------------------------------------------------------------------------
--[[Prop|Header]]   Movement  		= "" 
--[[Prop|float]]	Walk_Speed 		= 1.3
--[[Prop|float]]	RunSpeed 		= 4.0
--[[Prop|float]]	JumpForce 		= 24	
--[[Prop|float]]	TurningSpeed 	= 200	


---------------------------------------------------------------------------------
-- EDITOR: MAPPER
---------------------------------------------------------------------------------
--[[Prop|Header]]   Keyboard_Mapper = "" 
--[[Prop|string]] 	Move_Forward	= "i"
--[[Prop|string]] 	Move_Backward	= "k"
--[[Prop|string]] 	Turn_Right		= "l"
--[[Prop|string]] 	Turn_Left		= "j"
--[[Prop|string]] 	Run_Key			= "shift"
--[[Prop|string]] 	Jump_Key		= "space"

--[[Prop|Header]]   Gamepad_Mapper  = "" 
--[[Prop|int]] 		Attack1_Pad		= 0
--[[Prop|int]] 		Attack2_Pad		= 2
--[[Prop|int]] 		Attack3_Pad		= 3
--[[Prop|int]] 		Attack4_Pad		= 4
--[[Prop|int]] 		Run_Pad			= 5
--[[Prop|int]] 		Jump_Pad		= 1


---------------------------------------------------------------------------------
-- EDITOR: AUDIO
---------------------------------------------------------------------------------
--[[Prop|Header]]   Character_Audio = "" ;
--[[Prop|string]] 	Audio_Footstep		= "walk_mono.ogg"
--[[Prop|string]] 	Audio_Taunt	 	 	= "melee.ogg"
--[[Prop|string]] 	Audio_Hurt		 	= "hurt.ogg"
--[[Prop|string]] 	Audio_KO		 	= "death.ogg"
--[[Prop|string]] 	Audio_Recover	 	= "Trance5_FX01.wav"
--[[Prop|string]] 	Audio_Jump		 	= "jump.ogg"
--[[Prop|string]] 	Audio_Land		 	= "land.ogg"
--[[Prop|string]] 	Audio_LandHard	 	= "hardland.ogg"
--[[Prop|string]] 	Audio_Attack_1		= "melee.ogg"
--[[Prop|string]] 	Audio_Attack_2		= "melee.ogg"
--[[Prop|string]] 	Audio_Attack_3		= "melee.ogg"
--[[Prop|string]] 	Audio_Attack_4 	 	= "melee.ogg"
--[[Prop|string]] 	Audio_SLASHSOUND	= "Bloody Hit 2.wav"


---------------------------------------------------------------------------------
-- EDITOR: ANIMATION EXTRA
---------------------------------------------------------------------------------
--[[Prop|Header]]   Attack_LengthDelay= "" ;
--[[Prop|int]] 		Attack1_AnimLength	= 500;
--[[Prop|int]] 		Attack2_AnimLength	= 500;
--[[Prop|int]] 		Attack3_AnimLength 	= 500;	
--[[Prop|int]] 		Attack4_AnimLength	= 500;

--[[Prop|Header]]   Attack_DamageDelay= "" ;
--[[Prop|int]] 		Attack1_DamageDelay	= 500;	
--[[Prop|int]] 		Attack2_DamageDelay	= 500;	
--[[Prop|int]] 		Attack3_DamageDelay = 500;	
--[[Prop|int]] 		Attack4_DamageDelay	= 500;

--[[Prop|Header]]   Attack_SoundDelay= "" ;
--[[Prop|int]] 		Attack1_SoundDelay	= 500;	
--[[Prop|int]] 		Attack2_SoundDelay	= 500;	
--[[Prop|int]] 		Attack3_SoundDelay 	= 500;	
--[[Prop|int]] 		Attack4_SoundDelay	= 500;

--[[Prop|Header]]   Animation_Timing	= "" ;
--[[Prop|float]]	TakeHit_AnimLength	= 200
--[[Prop|float]] 	Global_Speed		= 1.0;	
TakeHit_interval	= 200;


---------------------------------------------------------------------------------
-- EDITOR: DETECTION
---------------------------------------------------------------------------------
--[[Prop|Header]]   Detection  			= "" 
--[[Prop|int]]		Character_Flag		= 2
--[[Prop|string]]	Target_Flag			= "1|3"

queryFlag 		= 2;
targetFlag 		= "1|3";


---------------------------------------------------------------------------------
-- EDITOR: STATS
---------------------------------------------------------------------------------
--[[Prop|Header]]   Stats = "" ;
--[[Prop|float]] 	Health				= 100
--[[Prop|float]] 	Attack_FOV			= 40
--[[Prop|float]] 	Attack_Damage		= 10


---------------------------------------------------------------------------------
-- Widget Callback
---------------------------------------------------------------------------------
function SetDynamicProperty(id,param,value)
	if(param=="Update_Values")then setupGame(id); end
end




---------------------------------------------------------------------------------
-- USER DATA
---------------------------------------------------------------------------------
jump_soundDelay			= 800; --
attack1_soundDelay 		= 500;	-- time in ms
attack2_soundDelay 		= 500;	-- time in ms
attack3_soundDelay 		= 500;	-- time in ms
attack4_soundDelay 		= 500;	-- time in ms

attack1_damageDelay 	= 500;	-- time in ms
attack2_damageDelay 	= 500;	-- time in ms
attack3_damageDelay 	= 500;	-- time in ms
attack4_damageDelay 	= 500;	-- time in ms

attack1_animLength 		= 500;	-- time in ms
attack2_animLength		= 500;	-- time in ms
attack3_animLength 		= 500;	-- time in ms
attack4_animLength 		= 500;	-- time in ms

Character_StepSize 		= 0.4;
Character_FallSpeed 	= -9;
Character_SlopeLimit 	= 70;
Character_FlipZ 		= 0;
Character_SkinWidth 	= 0.1;
Character_jumpDownForce	= 40;

---------------------------------------------------------------------------------
-- PRIVATE DATA
---------------------------------------------------------------------------------
ox,oy,oz 					= 0;
obj 						= 0;
walkSpeed 					= Walk_Speed;
turnSpd 					= 0;
attacking 					= 0;
jumping						= 0;
dccID						= 0;
move 						= 0;
turnVal						= 0;
moveVal 					= 0;
running						= false;
moveSpeed 					= 0;
shiftKeyDown 				= false;
CURRENT_ANIM 				= "idle";
NON_ATTACK_ANIM 			= CURRENT_ANIM;
sound_footstep				= 0
sound_jumping				= 0
attackMseCount 				= 0;
doDamage					= false;
takingDamge					= false;

TIMER_JUMP					= 1
TIMER_ATTACK1				= 2;
TIMER_ATTACK1_SOUNDDELAY	= 3;
TIMER_ATTACK1_DAMAGEDELAY	= 4;
TIMER_JUMP_SOUNDDELAY		= 5;
TIMER_TAKEHIT_1 			= 6;

function setupDefaults()
	ox,oy,oz 				= entity.getPosition(obj);
	sound_footstep			= 0
	sound_jumping			= 0
	move 					= 0;
	turnVal 				= 0;
	jumping 				= 0;
	attacking 				= 0;
	playerKO 				= 0;
	running					= false;
	shiftKeyDown 			= false;
	CURRENT_ANIM 			= IDLE_1;
	attackMseCount 			= 0;
	attack_FOV				= 40;
	attack_Damage			= 50;
end


---------------------------------------------------------------------------------
-- SETUP DATA
---------------------------------------------------------------------------------
function setupGame(id)
	setupDefaults();
	setup_DynamicValues(id);
	setup_Mapping(id);
	setup_Capsule(id);	
	setup_Anim(id);
	setup_Audio(id);
	setupStats(id);	
	sensorID = action.getActionID(id, "AI Sensor")
	action.setActionParam(id, sensorID, "AIS Query Data", targetFlag);	
end


function setup_DynamicValues( id )
	Character_Height	= tonumber(	entity.getDynamicProperty(id, "Character_Height"));
	Character_Offset	= tonumber(	entity.getDynamicProperty(id, "Character_Offset"));
	Character_Width		= tonumber(	entity.getDynamicProperty(id, "Character_Width"));
	
	Walk_Speed 			= tonumber(	entity.getDynamicProperty(id, "Walk_Speed"));
	runSpeed			= tonumber(	entity.getDynamicProperty(id, "RunSpeed"));
	jumpForce			= tonumber(	entity.getDynamicProperty(id, "JumpForce"));
	turnSpeed			= tonumber(	entity.getDynamicProperty(id, "TurningSpeed"));

	TakeHit_interval 	= tonumber( entity.getDynamicProperty(id, "TakeHit_AnimLength" 	));
	
	queryFlag			= tonumber(	entity.getDynamicProperty(id, "Character_Flag"	));
	targetFlag			= entity.getDynamicProperty(id, "Target_Flag");
	
end

function setup_Audio(id)
	sound.setLooped( 0 );
	sound.setVolume( 1 );
	sound.setLooped( 1 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Footstep"	)); AUDIO_FOOTSTEP	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Taunt"	 	)); AUDIO_TAUNT		= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_KO"	 	)); AUDIO_KO		= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Hurt"	 	)); AUDIO_HURT		= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Land"	 	)); AUDIO_LAND		= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Landhard"	)); AUDIO_LANDHARD	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_1"	)); AUDIO_ATTACK1	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_2"	)); AUDIO_ATTACK2	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_3"	)); AUDIO_ATTACK3	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_4"	)); AUDIO_ATTACK4	= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_1_Contact"	)); AUDIO_ATTACK1_CONTACT	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Jump"		)); AUDIO_JUMP		= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Recover"	)); AUDIO_RECOVER	= sound.create2DSound();
end

function setup_Mapping(id)
	KEY_WALK_FORWARD	= entity.getDynamicProperty(id, "Move_Forward");
	KEY_WALK_BACKWARD	= entity.getDynamicProperty(id, "Move_Backward");
	KEY_TURN_RIGHT		= entity.getDynamicProperty(id, "Turn_Right");
	KEY_TURN_LEFT		= entity.getDynamicProperty(id, "Turn_Left");
	KEY_JUMP			= entity.getDynamicProperty(id, "Jump_Key");
	KEY_RUN				= entity.getDynamicProperty(id, "Run_Key");
	
	PAD_ATTACK1			= tonumber(	entity.getDynamicProperty(id, "Attack1_Pad"));
	PAD_ATTACK2			= tonumber(	entity.getDynamicProperty(id, "Attack2_Pad"));
	PAD_ATTACK3			= tonumber(	entity.getDynamicProperty(id, "Attack3_Pad"));
	PAD_ATTACK4			= tonumber(	entity.getDynamicProperty(id, "Attack4_Pad"));
	PAD_RUN				= tonumber(	entity.getDynamicProperty(id, "Run_Pad"));
	PAD_JUMP			= tonumber(	entity.getDynamicProperty(id, "Jump_Pad"));
end

function setup_Anim(id)
	IDLE_1 		= anim.getFromMap(id,"Idle1");
	WALK 		= anim.getFromMap(id,"Walk");
	RUN			= anim.getFromMap(id,"Run");
	JUMP		= anim.getFromMap(id,"Jump");
	KO1			= anim.getFromMap(id,"Ko1");
	ATTACK_1	= anim.getFromMap(id,"Attack1");
	ATTACK_2	= anim.getFromMap(id,"Attack2");
	ATTACK_3	= anim.getFromMap(id,"Attack3");
	ATTACK_4	= anim.getFromMap(id,"Attack4");
	TAKEHIT_1	= anim.getFromMap(id,"TakeHit_1");
	
	anim.setLooped(id, KO1, 0);
	
	anim.setEnabled(id, WALK,		0);
	anim.setEnabled(id, RUN, 		0);
	anim.setEnabled(id, ATTACK_1, 	0);
	anim.setEnabled(id, ATTACK_2, 	0);
	anim.setEnabled(id, ATTACK_3, 	0);
	anim.setEnabled(id, ATTACK_4, 	0);
	anim.setEnabled(id, JUMP, 		0);
	anim.setEnabled(id, KO1, 		0);
	anim.setEnabled(id, TAKEHIT_1,	0);
	anim.setEnabled(id, IDLE_1, 	1);
	
	CURRENT_ANIM 	= IDLE_1;
	NON_ATTACK_ANIM = CURRENT_ANIM;
	
	moveSpeed = Walk_Speed; 
	
	attack1_animLength 	= entity.getDynamicProperty(id, "Attack1_AnimLength" )
	attack2_animLength	= entity.getDynamicProperty(id, "Attack2_AnimLength" )
	attack3_animLength 	= entity.getDynamicProperty(id, "Attack3_AnimLength" )
	attack4_animLength 	= entity.getDynamicProperty(id, "Attack4_AnimLength" )	

	attack1_damageDelay = entity.getDynamicProperty(id, "Attack1_DamageDelay")
	attack2_damageDelay = entity.getDynamicProperty(id, "Attack2_DamageDelay")
	attack3_damageDelay = entity.getDynamicProperty(id, "Attack3_DamageDelay")
	attack4_damageDelay = entity.getDynamicProperty(id, "Attack4_DamageDelay")
	attack1_soundDelay 	= entity.getDynamicProperty(id, "Attack1_SoundDelay" )
	attack2_soundDelay 	= entity.getDynamicProperty(id, "Attack2_SoundDelay" )
	attack3_soundDelay 	= entity.getDynamicProperty(id, "Attack3_SoundDelay" )
	attack4_soundDelay 	= entity.getDynamicProperty(id, "Attack4_SoundDelay" )
	
	animation_speed 	= tonumber(	entity.getDynamicProperty(id, "Global_Speed" ))
end

function setup_Capsule(id)	
	if(dccID~=-1)then controller.remove(dccID);	end	
	controller.setData_Offset(0,Character_Offset,0);	
	controller.setData_characterHeight(Character_Height);	
	controller.setData_shapeType(0);	
	controller.setData_characterWidth(Character_Width);	
	controller.setData_stepOffset(Character_StepSize); 	
	controller.setData_gravityY(Character_FallSpeed);	
	controller.setData_slopeLimit(Character_SlopeLimit);	
	controller.setData_flipDirection(Character_FlipZ); 	
	controller.setData_skinWidth(Character_SkinWidth);	
	controller.setData_upDirectionIndex(1);		
	dccID = controller.spawn(obj);	
	controller.setJumpDownforce(dccID,Character_jumpDownForce);	
	-- Ensure the character is above the ground, so no falling thro	
	controller.setPosition(dccID,wx,wy+Character_Height*0.5+0.5,wz)
	controller.setQueryFlag(dccID,queryFlag)
end

function setup_Effects()
	--effectDuration 	= 0			-- Time this effect will live in ms( 1000ms = 1sec ) 0 = constant
  --effectDuration  = 0;     -- Time this effect will live in ms( 1000ms = 1sec )
  --particleFile    = "mp2_explosion_20";   -- this is a *.skyparticle file without the extension
  --particle.setEffectDuration(effectDuration);
  --particle.setEffectFile(particleFile);
  --particle.setVisibleDistance(80);
	--PU_ID = particle.PU_Create() -- create the PU particle 
  --particle.setScale( PU_ID ,0.2, 0.2, 0.2)
end

function setupStats(id)
	health			= tonumber(	entity.getDynamicProperty(id, "Health"));
	attack_FOV		= tonumber(	entity.getDynamicProperty(id, "Attack_FOV"));
	attack_Damage	= tonumber(	entity.getDynamicProperty(id, "Attack_Damage"));
end

---------------------------------------------------------------------------------
-- EVENTS
---------------------------------------------------------------------------------
function onInit(objID)
	obj 		= objID;
	dccID 	= -1;
	--resource.preparePreset("Default Player Fireball 1A");
	wx,wy,wz = entity.getPosition(obj);
	setupGame(obj);
	--setup_Effects();
	CURRENT_ANIM 	= IDLE_1;
	
end

function postInit()
	anim.playAnimation(obj, CURRENT_ANIM, 30, 1);
end

function onUpdate( td )
	moveSpd = 0;
	wx,wy,wz = entity.getPosition(obj);
	if(playerKO == 1)	then return; end	
	if(attacking == 1) 	then controller.move(dccID, 0 ); return; end
	if(move ==  1) 		then moveSpd =  moveSpeed; end
	if(move == -1) 		then moveSpd = -moveSpeed; end
	if(jumping == 0)	then anim.playAnimation(obj, CURRENT_ANIM, 30, 1); end

	entity.turn(obj, 0, turnVal*td , 0);
	controller.move(dccID, moveSpd ); 
	if(sound_footstep==1)then sound.changePosition( AUDIO_FOOTSTEP, wx,wy,wz ); end
end

function onStop(  )
	anim.playAnimation(obj, IDLE_1, 30, 0);
end

---------------------------------------------------------------------------------
-- SENSOR
---------------------------------------------------------------------------------
-- Players dame field of view. If any npc is in range then dish out damage.
function onSensorContact_Stay( testTable )
	if(doDamage==true) then
		for k,targetID in ipairs( testTable ) do
			x,y,z 		= vector3.normalisedCopy(entity.getDirection(targetID,obj));
			direction 	= newType.vec3(entity.getDirection(obj,targetID));
			forward 	= newType.vec3(entity.getForward(obj));
			angle 		= vector3.angle(direction.x, direction.y, direction.z, forward.x, forward.y, forward.z );
			if(angle<attack_FOV)then action_DamageEnemy(targetID, attack_Damage); end
		end
		doDamage=false;
	end 
end



---------------------------------------------------------------------------------
-- ACTION - Stuff the character needs to perform in game
---------------------------------------------------------------------------------
function action_AttackStart(type)
	if(playerKO==1)then return; end
	attack_AnimLength 	= 0;
	attack_SoundDelay	= 0;
	attack_DamageDelay	= 0;
	--takingDamge = true;
	--time.stopMultiTimer(TIMER_ATTACK1_DAMAGEDELAY, obj);
	if(attacking==0 and jumping==0)then
		attackAnim 		= ATTACK_1;
		NON_ATTACK_ANIM = CURRENT_ANIM;
		if		(type==1) then 
			attackAnim = ATTACK_1; 
			attack_AnimLength 	= attack1_animLength 	
			attack_SoundDelay 	= attack1_soundDelay 	
			attack_DamageDelay 	= attack1_damageDelay	
		elseif	(type==2) then 
			attackAnim = ATTACK_2; 
			attack_AnimLength 	= attack2_animLength	
			attack_SoundDelay 	= attack2_soundDelay 	
			attack_DamageDelay 	= attack2_damageDelay	
		elseif	(type==3) then 
			attackAnim = ATTACK_3; 
			attack_AnimLength 	= attack3_animLength 	
			attack_SoundDelay 	= attack3_soundDelay 	
			attack_DamageDelay 	= attack3_damageDelay	
		elseif	(type==4) then 
			attackAnim = ATTACK_4; 
			attack_AnimLength 	= attack4_animLength 	
			attack_SoundDelay 	= attack4_soundDelay 	
			attack_DamageDelay 	= attack4_damageDelay	
		end
		--anim_AttackDelay = anim.getLength(obj, attackAnim)*1000 - 500;	
		CURRENT_ANIM = attackAnim;
		anim.playAnimation(obj, CURRENT_ANIM, 30, 1);
		attacking 		= 1;
		time.startMultiTimer( TIMER_ATTACK1, obj, attack_AnimLength );
		time.startMultiTimer( TIMER_ATTACK1_DAMAGEDELAY,obj, attack_DamageDelay );
		time.startMultiTimer( TIMER_ATTACK1_SOUNDDELAY, obj, attack_SoundDelay	);
		sound.stopSound( AUDIO_FOOTSTEP );	
		sound_footstep = 0;
	end
end


function action_AttackStop()
	CURRENT_ANIM = NON_ATTACK_ANIM;
	attacking = 0;
	sound_footstep = 0;
	if(sound_footstep==0 and move>0)then
		sound.play3DSound( AUDIO_FOOTSTEP, wx,wy,wz);
		sound_footstep = 1;	
	end		
	doDamage=false;
end

function action_DamageEnemy(targetID, damageAmt)
	local result = game.doDamage(targetID,0,0,0, damageAmt,100)
	--sky.lprint(result);
	--sound.play3DSound( Audio_SLASHSOUND, wx,wy,wz);
end

function action_JumpingStart()
	if(playerKO==1)then return; end
	if(jumping==0 and attacking == 0)then
		jumping = 1;
		anim.playAnimation(obj, JUMP, 30, 1);
		NON_ATTACK_ANIM = CURRENT_ANIM;
		CURRENT_ANIM 	= JUMP;
		time.startMultiTimer(TIMER_JUMP,obj,50);
		time.startMultiTimer(TIMER_JUMP_SOUNDDELAY,obj,jump_soundDelay);
		sound.stopSound( AUDIO_FOOTSTEP );	
		sound_footstep = 0;		
		--if(sound_jumping==0 and move>0)then
		sound.play3DSound( AUDIO_JUMP, wx,wy,wz);
		sound_jumping = 1;	
		--end			
		--controller.doJump(dccID, jumpForce); -- move to start on timer for barbarian.
	end
end

function action_JumpingStop()
	CURRENT_ANIM = NON_ATTACK_ANIM;
	jumping = 0;
	--sound_jumping = 0
end

function action_Shoot()
	--entity.callPublicFn(obj,sid,obj);
end

function action_KO()
	if(playerKO==1)then return; end
	controller.move(dccID, 0 );
	setupDefaults();
	sound.stopSound( AUDIO_FOOTSTEP );	
	sound.play3DSound( AUDIO_KO, wx,wy,wz);
	anim.playAnimation(obj, KO1, 30, 1);
	playerKO = 1;
end

function action_Recover()
	setupDefaults();
	controller.setPosition(dccID,ox,oy+Character_Height*0.5+0.5,oz)		
	sound.play3DSound( AUDIO_RECOVER, wx,wy,wz);
	anim.playAnimation(obj, "recover", 30, 1);
	damage_actionID = action.getActionID(obj, "Damage System")
	action.setActionParam(obj, damage_actionID, "DS Health", health);	
end


---------------------------------------------------------------------------------
-- TIMERS
---------------------------------------------------------------------------------
function onMultiTimer(timerID)

	--..................................................................
	--... JUMP
	--| Used to delay the capsules jump so it can match the animation
	if(timerID == TIMER_JUMP)then
		time.stopMultiTimer(TIMER_JUMP, obj);
		controller.doJump(dccID, jumpForce); -- special for barbarian
		action_JumpingStop(); 		
	end

	if(timerID == TIMER_JUMP_SOUNDDELAY)then
		time.stopMultiTimer(TIMER_JUMP_SOUNDDELAY, obj);
		sound.play3DSound( AUDIO_LAND, wx,wy,wz);	
		if(sound_footstep==0 and move>0)then
			sound.play3DSound( AUDIO_FOOTSTEP, wx,wy,wz);
			sound_footstep = 1;	
		end		
		sound_jumping = 0
	end
	
	--..................................................................
	--... ATTACK 1
	--| Stop the attacking action once the animation has completed
	if(timerID == TIMER_ATTACK1)then
		time.stopMultiTimer(TIMER_ATTACK1, obj);
		action_AttackStop();
	end
	
	--| Add a delay to the attack sound to match aniamtion
	if(timerID == TIMER_ATTACK1_SOUNDDELAY)then
		time.stopMultiTimer(TIMER_ATTACK1_SOUNDDELAY, obj);
		sound.play3DSound( AUDIO_ATTACK1, wx,wy,wz);
		--doDamage=true
	end
	
	if(timerID == TIMER_ATTACK1_DAMAGEDELAY)then
		time.stopMultiTimer(TIMER_ATTACK1_DAMAGEDELAY, obj);
		doDamage=true
	end


	--..................................................................
	--... TakeHit
	--| Stop the attacking action once the animation has completed
	if(timerID == TIMER_TAKEHIT_1)then
		time.stopMultiTimer(TIMER_TAKEHIT_1, obj);
		CURRENT_ANIM = NON_ATTACK_ANIM;
		if(playerKO==1)then return; end
		--if(attacking==1)then
		--	anim.playAnimation(obj, ATTACK_1, 30, 1);
		--else
		--	anim.playAnimation(obj, CURRENT_ANIM, 30, 0);
		--end
		takingDamge = false;
	end
end	


---------------------------------------------------------------------------------
-- MOVEMENT
---------------------------------------------------------------------------------
function doMove(state,flag)
	if(playerKO==1)then return; end
	takingDamge = false;
	if(state == true) then
		if(running==false or shiftKeyDown == false) then 
			CURRENT_ANIM 	= WALK; 
		else 
			CURRENT_ANIM 	= RUN; 
		end
		move = 1*flag;
		if(sound_footstep==0)then
			sound.play3DSound( AUDIO_FOOTSTEP, wx,wy,wz);
			sound_footstep = 1;	
		end
		
		anim.setSpeed(obj,CURRENT_ANIM, animation_speed);
		if(flag==-1)then anim.setSpeed(obj,CURRENT_ANIM, -animation_speed); end
	else
		move = 0; 
		CURRENT_ANIM = IDLE_1;	
		sound.stopSound( AUDIO_FOOTSTEP );	
		sound_footstep = 0;
	end
	NON_ATTACK_ANIM = CURRENT_ANIM	
end

function doRun(state)
	if(playerKO==1)then return; end
	if(state == true) then
		moveSpeed = runSpeed 
		if(move==1)then CURRENT_ANIM = RUN;end
		running = true;
	else
		if(move==1)then CURRENT_ANIM = WALK;end
		moveSpeed = Walk_Speed; 
		running = false;
	end
	NON_ATTACK_ANIM = CURRENT_ANIM	
end

function doTurn(val)
	if(playerKO==1)then return; end
	turnVal = val ;
	if(turnVal==0)then
		if(move==0)then
			sound.stopSound( AUDIO_FOOTSTEP );	
			sound_footstep = 0;	
		end	
		if(move==0)then doMove(false,0); end
	else --make walk sound if not moving, only turning
		if(sound_footstep == 0 )then
			sound.play3DSound( AUDIO_FOOTSTEP, wx,wy,wz);
			sound_footstep = 1;	
		end	
		if(move==0)then CURRENT_ANIM = WALK; end
	end
end


---------------------------------------------------------------------------------
-- INPUT: MOUSE+KEYS 
---------------------------------------------------------------------------------
function onMouseDown( button, x, y ) 
	if(button == 1)then 
		attackMseCount = attackMseCount+1;
		if(attackMseCount>3)then attackMseCount = 1; end
		action_AttackStart(attackMseCount); 
	end 
	if(button == 2)then action_AttackStart(4); end 
end 

function onKeyDown( key )
	if(key==KEY_RUN) then 
		shiftKeyDown = true; 
		doRun(true); 
	end
	
	if(key == KEY_JUMP) then action_JumpingStart();	end

	if 		(key == KEY_WALK_FORWARD) 	then doMove(true,1);
	elseif 	(key == KEY_WALK_BACKWARD) 	then doMove(true,-1); end
	
	if 		(key == KEY_TURN_LEFT)then 	doTurn(turnSpeed);		
	elseif 	(key == KEY_TURN_RIGHT)then doTurn(-turnSpeed);	end
	
	if(key=="t")then action_KO(); end
	if(key=="r")then action_Recover(); end
end

function onKeyUp( key )
	if (key==KEY_RUN)then 
		doRun(false); 
		shiftKeyDown = false; 
	end
	
	if 		(key == KEY_WALK_FORWARD) 	then doMove(false);
	elseif 	(key == KEY_WALK_BACKWARD) 	then doMove(false); end
	
	if(key == KEY_TURN_LEFT)then doTurn(0); end
	if(key == KEY_TURN_RIGHT)then doTurn(0); end 
end
 
 
---------------------------------------------------------------------------------
-- INPUT: GAMEPAD
---------------------------------------------------------------------------------
function onJSAxisMoved(axis, value)
	--| MOVE 
	if(axis==0) then 
		if(value<-400 or value > 400)then 
			moveVal = 0;
			if(value ~= 0) then
				--moveVal = -value*0.0001; 
				--doMove(true,1)
				--doRun(true);
				--shiftKeyDown = true;
				--anim.setSpeed(obj, "run", moveVal);
				if(value<0) then doMove(true,1); else doMove(true,-1); end
			end
		else
			doMove(false);
		end
	end

	--| TURN
	if(axis==1) then 
		turnVal =0;
		if(value ~= 0) then
			--turnVal = -value*0.022;
			doTurn(-value*0.022)
			--doRun(true);shiftKeyDown = true;
			--anim.setSpeed(obj, "run", (-value*0.0001));			
		end
	end
end

function onJSButtonPressed(button)
	--sky.print("GAME PAD BUTTON[ "..button.." ]");
	if		(button==PAD_ATTACK1) 	then action_AttackStart(1); 
	elseif	(button==PAD_ATTACK2) 	then action_AttackStart(2); 
	elseif	(button==PAD_ATTACK3) 	then action_AttackStart(3); 
	elseif	(button==PAD_ATTACK4) 	then action_AttackStart(4); 
	elseif	(button==PAD_RUN) 		then doRun(true);shiftKeyDown = true;
	elseif	(button==PAD_JUMP) 		then action_JumpingStart(); end;
end

function onJSButtonReleased(button)
	if	(button==PAD_RUN) then 
		doRun(false);
		shiftKeyDown = false;
	end
end
		


---------------------------------------------------------------------------------
-- DAMAGE - Player sustains damage and health check.
---------------------------------------------------------------------------------
function ds_onDamage( health, damage )
	if(playerKO==1)then return; end
	sky.lprint("Player Health: "..health.."  Damage: "..damage,1);
	wx,wy,wz = entity.getPosition(obj);
	sound.play3DSound( AUDIO_HURT, wx,wy,wz);
	if(takingDamge==false)then
		NON_ATTACK_ANIM = CURRENT_ANIM;
		CURRENT_ANIM = TAKEHIT_1;
		anim.playAnimation(obj, CURRENT_ANIM, 30, 0);
		time.startMultiTimer(TIMER_TAKEHIT_1,obj,TakeHit_interval);
		takingDamge = true;
	end
end


function ds_onKo( health, damage )
	action_KO()
	sky.callGlobalFn(obj,"playerKO");
end	






