-- |    _____ _          _ _                 _                      ______    _ _ _              

-- |   / ____| |        | (_)               | |                    |  ____|  | (_) |             

-- |  | (___ | | ___   _| |_ _ __   ___     | |    _   _  __ _     | |__   __| |_| |_ ___  _ __  

-- |   \___ \| |/ / | | | | | '_ \ / _ \    | |   | | | |/ _` |    |  __| / _` | | __/ _ \| '__| 

-- |   ____) |   <| |_| | | | | | |  __/    | |___| |_| | (_| |    | |___| (_| | | || (_) | |    

-- |  |_____/|_|\_\\__, |_|_|_| |_|\___|    |______\__,_|\__,_|    |______\__,_|_|\__\___/|_|    

-- |                __/ |                                                                        

-- |               |___/                                                                         



-- |==========================================================================================================================================

-- | Constructors



-- | Player Character: SHOOTER



function entity_main(objID)

	sky.lprint("Generating Player Character: SHOOTER");

	

	--set player Tag

	entity.setTag(objID,"player");

	

	--|----------------------------------------------------------------------------------------------------

	--| ADD SENSOR

	--|----------------------------------------------------------------------------------------------------

	sensorID = action.getActionID(objID, "AI Sensor")



	if(sensorID<=0)then

		sensorID = action.addToEntity(objID,"PLAYER", "AI Sensor");

	else

		sky.lprint("Warning: Adding Action - AI Sensor Action is already active.");

	end

	

	action.setActionParam(objID, sensorID, "AIS Bounds Check Type","1@Closest|All");

	action.setActionParam(objID, sensorID, "AIS Query Data","1");

	action.setActionParam(objID, sensorID, "AIS Bounds Radius","3");

	--action.setActionParam(objID, sensorID, "AIS Query Data","1|3"); set up in the external object dynamic properties script

	

	--|----------------------------------------------------------------------------------------------------

	--| ADD DAMAGE

	--|----------------------------------------------------------------------------------------------------

	damageID = action.getActionID(objID, "Damage System")



	if(damageID<=0)then

		damageID = action.addToEntity(objID,"PLAYER", "Damage System");

	else

		sky.lprint("Warning: Adding Action - Damage System Action is already active.");

	end

	

	action.setActionParam(objID, damageID, "DS Health","100");

	action.setActionParam(objID, damageID, "DS Enable KO Effects","false");

	action.setActionParam(objID, damageID, "DS KO Audio Enable","false");

	

	--|----------------------------------------------------------------------------------------------------

	--| ADD PLAYER CAMERA V2

	--|----------------------------------------------------------------------------------------------------

	cameraID = action.getActionID(objID, "Player Camera V2")



	if(cameraID<=0)then

		cameraID = action.addToEntity(objID,"CAMERA", "Player Camera V2");

	else

		sky.lprint("Warning: Adding Action - Player Camera Action is already active.");

	end

	

	action.setActionParam(objID, cameraID, "Use Mouse Y","true");

	action.setActionParam(objID, cameraID, "Camera X","0");

	action.setActionParam(objID, cameraID, "Camera Y","3");

	action.setActionParam(objID, cameraID, "Camera Z","0");

	

	action.setActionParam(objID, cameraID, "Look at Entity","player");

	action.setActionParam(objID, cameraID, "Target X","0");

	action.setActionParam(objID, cameraID, "Target Y","3");

	action.setActionParam(objID, cameraID, "Target Z","0");

	

	action.setActionParam(objID, cameraID, "Distance","-5");

	action.setActionParam(objID, cameraID, "Dampening","30");

	action.setActionParam(objID, cameraID, "Mass","50");

	action.setActionParam(objID, cameraID, "stiffness","2");

	

	--|----------------------------------------------------------------------------------------------------

	--| ADD WEAPON SHOOT

	--|----------------------------------------------------------------------------------------------------

	weaponShootID = action.getActionID(objID, "Weapon - Shoot")



	if(weaponShootID<=0)then

		weaponShootID = action.addToEntity(objID,"PLAYER", "Weapon - Shoot");

	else

		sky.lprint("Warning: Adding Action - Damage System Action is already active.");

	end	

	--action.setActionParam(objID, weaponShootID, "WS Weapon Key","Sky_Hit_Orig");

	action.setActionParam(objID, weaponShootID, "WS flip Ray","false");

	action.setActionParam(objID, weaponShootID, "WS Lock Shoot angle","false");

	

	--fpsSystem.setWeapon(objID,"Sky_Hit_Orig");

end



