-- |    _____ _          _ _                 _                      ______    _ _ _              
-- |   / ____| |        | (_)               | |                    |  ____|  | (_) |             
-- |  | (___ | | ___   _| |_ _ __   ___     | |    _   _  __ _     | |__   __| |_| |_ ___  _ __  
-- |   \___ \| |/ / | | | | | '_ \ / _ \    | |   | | | |/ _` |    |  __| / _` | | __/ _ \| '__| 
-- |   ____) |   <| |_| | | | | | |  __/    | |___| |_| | (_| |    | |___| (_| | | || (_) | |    
-- |  |_____/|_|\_\\__, |_|_|_| |_|\___|    |______\__,_|\__,_|    |______\__,_|_|\__\___/|_|    
-- |                __/ |                                                                        
-- |               |___/                                                                         

-- |==========================================================================================================================================
-- | Constructors - Automatically Add actions, scripts etc to objects for dynamic use

-- | Mechanic - Activate Message

function entity_main(objID)
	sky.lprint("Generating Activate Message Mechanic....");
	
	entity.setShadow(objID, 0 );
	
	--|----------------------------------------------------------------------------------------------------
	--| ADD SENSOR
	--|----------------------------------------------------------------------------------------------------
	sensorID = action.getActionID(objID, "AI Sensor")

	if(sensorID<=0)then
		sensorID = action.addToEntity(objID,"PLAYER", "AI Sensor");
	else
		sky.lprint("Warning: Adding Action - AI Sensor Action is already active.");
	end
	
	action.setActionParam(objID, sensorID, "AIS Bounds Check Type","0@Closest|All");
	action.setActionParam(objID, sensorID, "AIS Query Data","2");
	action.setActionParam(objID, sensorID, "AIS Bounds Radius","3");
	
	--|----------------------------------------------------------------------------------------------------
	--| ADD  3D TEXT
	--|----------------------------------------------------------------------------------------------------
	actionID = action.getActionID(objID, "UI - 3D Label")

	if(actionID<=0)then
		actionID = action.addToEntity(objID,"UI", "UI - 3D Label");
	else
		sky.lprint("Warning: Adding Action - UI - 3D Label Action is already active.");
	end
	
	action.setActionParam(objID, actionID, "Color","1,1,0");
	action.setActionParam(objID, actionID, "offset","0,0.3,0");
	
	
	--|----------------------------------------------------------------------------------------------------
	--| ADD  3D TEXT
	--|----------------------------------------------------------------------------------------------------
	actionID = action.getActionID(objID, "2D - Sprite")

	if(actionID<=0)then
		actionID = action.addToEntity(objID,"2D", "2D - Sprite");
	else
		sky.lprint("Warning: Adding Action - 2D - 2D - Sprite Action is already active.");
	end
	
	action.setActionParam(objID, actionID, "2D - Sprite Enabled","0");
	action.setActionParam(objID, actionID, "Image Position X","-75");
	action.setActionParam(objID, actionID, "Image Position Y","-70");
	action.setActionParam(objID, actionID, "Image Size X","150");
	action.setActionParam(objID, actionID, "Image Size Y","150");
	action.setActionParam(objID, actionID, "Blend Mode","4@SB_ADD|SB_COLOR|SB_ALPHA|SB_MODULATE|SB_REPLACE|SB_MINUS");
	action.setActionParam(objID, actionID, "Alpha Add","false");
	
	
	
	--fpsSystem.setWeapon(objID,"Sky_Hit_Orig");
end

