--=================================================================================
-- Skyline Lua dynamic Scipt - Animal AI ( Evade )
-- 2015 Requires Skyline Version 0.9.4 or greater
--=================================================================================

--[[HeaderImage|Mechanic_ActivateMessage_DynamicProperty_header.png]]

---------------------------------------------------------------------------------
-- EDITOR: DETECTION
---------------------------------------------------------------------------------
--[[Prop|Header]]   Sensor_Detection  	= "" 
--[[Prop|float]]	Sensor_Radius 		= 3		
--[[Prop|string]]	Detection_Flag 		= "2"		

detectionFlag = "2"
sensorRadius = 3

---------------------------------------------------------------------------------
-- EDITOR: MAPPER
---------------------------------------------------------------------------------
--[[Prop|Header]]   Keyboard_Mapper = "" 
--[[Prop|string]] 	Activate_Key	= "e"

activateKey = "e"

---------------------------------------------------------------------------------
-- EDITOR: 3D TEXT
---------------------------------------------------------------------------------
--[[Prop|Header]]  	Text_3D  		= "" 
--[[Prop|string]]	Text	 		= "Read Note - Press E Key"		

txt = "Read Note - Press E Key"	

---------------------------------------------------------------------------------
-- EDITOR: UI Display
---------------------------------------------------------------------------------
--[[Prop|Header]]  	UI  			= "" 
--[[Prop|string]]	Image_File	 	= "MerilarsJournal.png"		

imageName = "MerilarsJournal.png"

---------------------------------------------------------------------------------
-- PRIVATE DATA
---------------------------------------------------------------------------------
obj 					= 0;
materialName			= ""
uiEnable 				= false;


---------------------------------------------------------------------------------
-- SETUP DATA
---------------------------------------------------------------------------------
function setupGame(id)
	setupDefaults();
	setup_DynamicValues( id )
	sensorID = action.getActionID(id, "AI Sensor")
	action.setActionParam(id, sensorID, "AIS Bounds Radius", sensorRadius);	
	action.setActionParam(id, sensorID, "AIS Query Data", detectionFlag);
	
	actionID = action.getActionID(obj, "UI - 3D Label")
	action.setActionParam(obj, actionID, "Caption", txt);

	actionID = action.getActionID(obj, "2D - Sprite")
	action.setActionParam(obj, actionID, "Image File", imageName);

end

function setupDefaults()
	uiEnable 				= false;
	materialName = entity.getMaterialName(obj, 0);
	entity.setMaterialName(obj, "Invisible");
end

function setup_DynamicValues( id )
	detectionFlag	= entity.getDynamicProperty(id, "Detection_Flag");
	sensorRadius	= tonumber(	entity.getDynamicProperty(id, "Sensor_Radius"));
	activateKey		= entity.getDynamicProperty(id, "Activate_Key");
	txt				=entity.getDynamicProperty(id, "Text");
	imageName		=entity.getDynamicProperty(id, "Image_File");
end

---------------------------------------------------------------------------------
-- MAIN
---------------------------------------------------------------------------------
function onInit(objID)
	obj = objID;
	setupGame(objID)
	sky.print("Game Mechanic ID:"..obj.." Sensor Actived"); 
	actionID = action.getActionID(obj, "UI - 3D Label")
	action.setActionParam(obj, actionID, "Enable 3D Label", "0");
	sky.lprint("TEST*************************************",0);
end


function onSensorContact_Enter(targetID,distance)
	actionID = action.getActionID(obj, "UI - 3D Label")
	action.setActionParam(obj, actionID, "Enable 3D Label", "1");
	action.setActionParam(obj, actionID, "offset", "0,0.3,0");
	sky.print("Detected Target: "..targetID,1);
	uiEnable = true
end


function onSensorContact_Exit(targetID)
	sky.print("EXIT Target: "..targetID,1);
	actionID = action.getActionID(obj, "UI - 3D Label")
	action.setActionParam(obj, actionID, "Enable 3D Label", "0");
	uiEnable =false
end


function onKeyDown( key )
		actionID = action.getActionID(obj, "2D - Sprite")
		action.setActionParam(obj, actionID, "2D - Sprite Enabled", "0");

	if(key==activateKey and uiEnable==true)then
		sky.lprint("You Pressed the "..key.." Key");
		actionID = action.getActionID(obj, "2D - Sprite")
		action.setActionParam(obj, actionID, "2D - Sprite Enabled", "1");
	end
end


function onStop(  )
	entity.setMaterialName(obj, materialName);
end


