-- |------------------------------------------------------------------------------------
-- | .: S K Y L I N E :. 	New Lua Script. Script containing some common events		
-- |------------------------------------------------------------------------------------ 


--[[HeaderImage|Character_Player_Melee_DynamicProperty_header.png]]

--[[Prop|button]] Update_Values = "Update" 


---------------------------------------------------------------------------------
-- EDITOR: PHYSICS
---------------------------------------------------------------------------------
--[[Prop|Header]]   Character_Size 		= "" 
--[[Prop|float]]	Character_Height 	= 1.0;
--[[Prop|float]]	Character_Offset 	= -1.3;
--[[Prop|float]]	Character_Width 	= 0.4;

---------------------------------------------------------------------------------
-- EDITOR: SPEED
---------------------------------------------------------------------------------
--[[Prop|Header]]   Movement  			= "" ;
--[[Prop|float]]	Walk_Speed 			= 1.25;
--[[Prop|float]]	RunSpeed 			= 2.0;
--[[Prop|float]]	JumpForce 			= 50;	-- Initial jump power
--[[Prop|float]]	TurningSpeed 		= 200;	-- max turning speed

---------------------------------------------------------------------------------
-- EDITOR: ANIMATION EXTRA
---------------------------------------------------------------------------------
--[[Prop|Header]]   Attack_Timings= "" ;
--[[Prop|int]] 		Attack1_AnimLength	= 1000;
--#[[Prop|int]] 		Attack2_AnimLength	= 1000;
--#[[Prop|int]] 		Attack3_AnimLength 	= 800;	
--#[[Prop|int]] 		Attack4_AnimLength	= 2000;

--#[[Prop|Header]]   Attack_DamageDelay= "" ;
--[[Prop|int]] 		Attack1_DamageDelay	= 400;	
--#[[Prop|int]] 		Attack2_DamageDelay	= 200;	
--#[[Prop|int]] 		Attack3_DamageDelay = 150;	
--#[[Prop|int]] 		Attack4_DamageDelay	= 1400;

--#[[Prop|Header]]   Attack_SoundDelay= "" ;
--[[Prop|int]] 		Attack1_SoundDelay	= 200;	
--#[[Prop|int]] 		Attack2_SoundDelay	= 160;	
--#[[Prop|int]] 		Attack3_SoundDelay 	= 120;	
--#[[Prop|int]] 		Attack4_SoundDelay	= 1200;

---------------------------------------------------------------------------------
-- EDITOR: AUDIO
---------------------------------------------------------------------------------
--[[Prop|Header]]   Character_Audio 	= "" ;
--[[Prop|string]] 	Audio_Footstep		= "walk_mono.ogg"
--[[Prop|string]] 	Audio_Taunt	 	 	= ""
--[[Prop|string]] 	Audio_Hurt		 	= "hurt.ogg"
--[[Prop|string]] 	Audio_KO		 	= "death.ogg"
--[[Prop|string]] 	Audio_Recover	 	= "Trance5_FX01.wav"
--[[Prop|string]] 	Audio_Jump		 	= "jump.ogg"
--[[Prop|string]] 	Audio_Land		 	= "land.ogg"
--[[Prop|string]] 	Audio_LandHard	 	= "hardland.ogg"
--[[Prop|string]] 	Audio_Attack_1		= "melee.ogg"
--[[Prop|string]] 	Audio_Attack_2		= "melee.ogg"
--[[Prop|string]] 	Audio_Attack_3		= "melee.ogg"
--[[Prop|string]] 	Audio_Attack_4 	 	= "melee.ogg"
--[[Prop|string]] 	Audio_SlashSound	= "Bloody Hit 2.wav"

---------------------------------------------------------------------------------
-- EDITOR: STATS
---------------------------------------------------------------------------------
--[[Prop|Header]]   Stats = "" ;
--[[Prop|float]] 	Health				= 100
--[[Prop|float]] 	Attack_FOV			= 40
--[[Prop|float]] 	Attack_Damage		= 5



---------------------------------------------------------------------------------

-- Widget Callback

---------------------------------------------------------------------------------

function SetDynamicProperty(id,param,value)

	if(param=="Update_Values")then setupGame(id); end

end


---------------------------------------------------------------------------------
-- USER DATA
---------------------------------------------------------------------------------
Character_StepSize 			= 0.4;
Character_FallSpeed 		= -9;
Character_SlopeLimit 		= 70;
Character_FlipZ 			= 0;
Character_SkinWidth 		= 0.1;
Character_jumpDownForce		= 40;


---------------------------------------------------------------------------------
-- PRIVATE DATA
---------------------------------------------------------------------------------
obj 						= 0;
playerKO					= 0;
attacking 					= 0;
move 						= 0;
running						= false;
moveSpeed 					= 0;
sound_footstep				= 0
targetID					= -1 
maxHealth					= 100;
currentHealth				= 100;
TIMER_TAKEHIT_1 			= 1;
TIMER_ATTACK1				= 2;
TIMER_ATTACK1_SOUNDDELAY	= 3;
TIMER_ATTACK1_DAMAGEDELAY	= 4;
playerKo					= false;
dccID 						= -1
wx,wy,wz 					= 0;
---------------------------------------------------------------------------------
-- SETUP DATA
---------------------------------------------------------------------------------
function setupGame(id)
	setupDefaults();

	setup_DynamicValues(id);
	setup_Capsule(id);	
	setup_Anim(id);
	setup_Audio(id);	
	setupStats(id);	
end

function setupDefaults()
	CURRENT_ANIM 	= IDLE_1;
	playerKO 		= 0;
	attacking		= 0;
	currentHealth	= maxHealth;
end

function setup_DynamicValues( id )
	Character_Height	= tonumber(	entity.getDynamicProperty(id, "Character_Height"));
	Character_Offset	= tonumber(	entity.getDynamicProperty(id, "Character_Offset"));
	Character_Width		= tonumber(	entity.getDynamicProperty(id, "Character_Width"));
	
---	Walk_Speed 			= tonumber(	entity.getDynamicProperty(id, "Walk_Speed"));
--	runSpeed			= tonumber(	entity.getDynamicProperty(id, "RunSpeed"));
--	jumpForce			= tonumber(	entity.getDynamicProperty(id, "JumpForce"));
--	turnSpeed			= tonumber(	entity.getDynamicProperty(id, "TurningSpeed"));
end

function setup_Capsule(id)	
	if(dccID~=-1)then controller.remove(dccID);	end	
	controller.setData_Offset(0,Character_Offset,0);	
	controller.setData_characterHeight(Character_Height);	
	controller.setData_shapeType(0);	
	controller.setData_characterWidth(Character_Width);	
	controller.setData_stepOffset(Character_StepSize); 	
	controller.setData_gravityY(Character_FallSpeed);	
	controller.setData_slopeLimit(Character_SlopeLimit);	
	controller.setData_flipDirection(Character_FlipZ); 	
	controller.setData_skinWidth(Character_SkinWidth);	
	controller.setData_upDirectionIndex(1);	
	
	dccID = controller.spawn(obj);	
	
	controller.setJumpDownforce(dccID,Character_jumpDownForce);	
	-- Ensure the character is above the ground, so no falling thro	
	controller.setPosition(dccID,wx,wy+Character_Height*0.5+0.5,wz)		
	controller.setQueryFlag(dccID,1)
end

function setup_Anim(id)
	IDLE_1 		= anim.getFromMap(id,"Idle1");
	WALK 		= anim.getFromMap(id,"Walk");
	RUN			= anim.getFromMap(id,"Run");
	JUMP		= anim.getFromMap(id,"Jump");
	KO_1		= anim.getFromMap(id,"Ko1");
	ATTACK_1	= anim.getFromMap(id,"Attack1");
	ATTACK_2	= anim.getFromMap(id,"Attack2");
	ATTACK_3	= anim.getFromMap(id,"Attack3");
	ATTACK_4	= anim.getFromMap(id,"Attack4");
	TAKEHIT_1	= anim.getFromMap(id,"TakeHit_1");
	TAKEHIT_2	= anim.getFromMap(id,"TakeHit_2");
	
	anim.setLooped(id, KO_1, 0);
	anim.setLooped(id, TAKEHIT_1, 0);
	anim.setLooped(id, TAKEHIT_2, 0);
	
	anim.setEnabled(id, WALK,		0);
	anim.setEnabled(id, RUN, 		0);
	anim.setEnabled(id, ATTACK_1, 	0);
	anim.setEnabled(id, ATTACK_2, 	0);
	anim.setEnabled(id, ATTACK_3, 	0);
	anim.setEnabled(id, ATTACK_4, 	0);
	anim.setEnabled(id, JUMP, 		0);
	anim.setEnabled(id, KO_1, 		0);
	anim.setEnabled(id, TAKEHIT_1, 	0);
	anim.setEnabled(id, TAKEHIT_2, 	0);
	anim.setEnabled(id, IDLE_1, 	1);
	
	CURRENT_ANIM 	= IDLE_1;
	NON_ATTACK_ANIM = CURRENT_ANIM;

	attack1_animLength 	= entity.getDynamicProperty(id, "Attack1_AnimLength" )
	--attack2_animLength	= entity.getDynamicProperty(id, "Attack2_AnimLength" )
	--attack3_animLength 	= entity.getDynamicProperty(id, "Attack3_AnimLength" )
	--attack4_animLength 	= entity.getDynamicProperty(id, "Attack4_AnimLength" )	

	attack1_damageDelay = entity.getDynamicProperty(id, "Attack1_DamageDelay")
	--attack2_damageDelay = entity.getDynamicProperty(id, "Attack2_DamageDelay")
	--attack3_damageDelay = entity.getDynamicProperty(id, "Attack3_DamageDelay")
	--attack4_damageDelay = entity.getDynamicProperty(id, "Attack4_DamageDelay")

	attack1_soundDelay 	= entity.getDynamicProperty(id, "Attack1_SoundDelay" )
	--attack2_soundDelay 	= entity.getDynamicProperty(id, "Attack2_SoundDelay" )
	--attack3_soundDelay 	= entity.getDynamicProperty(id, "Attack3_SoundDelay" )
	--attack4_soundDelay 	= entity.getDynamicProperty(id, "Attack4_SoundDelay" )

end


function setup_Audio(id)
	sound.setLooped( 0 );
	sound.setVolume( 1 );
	--sound.setLooped( 1 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Footstep"	)); AUDIO_FOOTSTEP	= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Taunt"	 	)); AUDIO_TAUNT		= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_KO"	 		)); AUDIO_KO		= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_SlashSound"	)); AUDIO_SLASHSOUND= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Hurt"	 	)); AUDIO_HURT		= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Land"	 	)); AUDIO_LAND		= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Landhard"	)); AUDIO_LANDHARD	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_1"	)); AUDIO_ATTACK1	= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_2"	)); AUDIO_ATTACK2	= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_3"	)); AUDIO_ATTACK3	= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Attack_4"	)); AUDIO_ATTACK4	= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Jump"		)); AUDIO_JUMP		= sound.create2DSound();
	--sound.setLooped( 0 );sound.setSoundFile(entity.getDynamicProperty(id, "Audio_Recover"	)); AUDIO_RECOVER	= sound.create2DSound();
	sound.setLooped( 0 );sound.setSoundFile( "haha_CrazyMunchkin.ogg"); AUDIO_HAHA	= sound.create2DSound();

end

function setupStats(id)
	maxHealth		= tonumber(	entity.getDynamicProperty(id, "Health"));
	attack_FOV		= tonumber(	entity.getDynamicProperty(id, "Attack_FOV"));
	attack_Damage	= tonumber(	entity.getDynamicProperty(id, "Attack_Damage"));
	currentHealth	= maxHealth;
end

---------------------------------------------------------------------------------
-- EVENTS
---------------------------------------------------------------------------------
function onInit(objID)
 	sky.lprint("Spawning AI");
	obj = objID;
	wx,wy,wz = entity.getPosition(obj);
	setupGame(obj);
end

function postInit()
	CURRENT_ANIM = IDLE_1
	anim.playAnimation(obj, CURRENT_ANIM, 30, 0);
	game.setHealth(obj,currentHealth);
end


function onStop(  )
	anim.playAnimation(obj, IDLE_1, 30, 0);
end

function ds_onKo() action_KO(); end


---------------------------------------------------------------------------------
-- ACTION - Stuff the character needs to perform in game
---------------------------------------------------------------------------------
function action_Recover()
	setupDefaults();
end

function action_AttackStart(target,type)
	if(playerKO==1)then return; end
	attack_AnimLength 	= 0;
	attack_SoundDelay	= 0;
	attack_DamageDelay	= 0;
	targetID = target
	if(attacking==0)then
		attackAnim 		= ATTACK_1;
		--NON_ATTACK_ANIM = CURRENT_ANIM;
		if		(type==1) then 
			attackAnim = ATTACK_1; 
			attack_AnimLength 	= attack1_animLength 	
			attack_SoundDelay 	= attack1_soundDelay 	
			attack_DamageDelay 	= attack1_damageDelay	
		end
		--anim_AttackDelay = anim.getLength(obj, attackAnim)*1000 - 500;	
		anim.playAnimation(obj, attackAnim, 30, 0);
		attacking 		= 1;
		time.startMultiTimer( TIMER_ATTACK1, obj, attack_AnimLength );
		time.startMultiTimer( TIMER_ATTACK1_DAMAGEDELAY,obj, attack_DamageDelay );
		time.startMultiTimer( TIMER_ATTACK1_SOUNDDELAY, obj, attack_SoundDelay	);
		--sound.stopSound( AUDIO_FOOTSTEP );	
		--sound_footstep = 0;
	end
end

function action_AttackStop()
	anim.playAnimation(obj, IDLE_1, 30, 0);
	attacking = 0;
	doDamage=false;
end
---------------------------------------------------------------------------------
-- TIMERS
---------------------------------------------------------------------------------
function onMultiTimer(timerID)

	--..................................................................
	--... TakeHit
	--| Stop the attacking action once the animation has completed
	if(timerID == TIMER_TAKEHIT_1)then
		time.stopMultiTimer(TIMER_TAKEHIT_1, obj);
		if(playerKO==1)then return; end
		if(attacking==1)then
			anim.playAnimation(obj, ATTACK_1, 30, 1);
		else
			anim.playAnimation(obj, CURRENT_ANIM, 30, 0);
		end
	end
		
	
	--..................................................................
	--... ATTACK 1
	--| Stop the attacking action once the animation has completed
	if(timerID == TIMER_ATTACK1)then
		--time.stopMultiTimer(TIMER_ATTACK1, obj);
		--action_AttackStop()
		if(playerKo==true)then time.stopMultiTimer(TIMER_ATTACK1, obj); end
		time.startMultiTimer( TIMER_ATTACK1_DAMAGEDELAY,obj, attack_DamageDelay );
		time.startMultiTimer( TIMER_ATTACK1_SOUNDDELAY, obj, attack_SoundDelay	);
		
	end
	
	--| Add a delay to the attack sound to match aniamtion
	if(timerID == TIMER_ATTACK1_SOUNDDELAY)then
		time.stopMultiTimer(TIMER_ATTACK1_SOUNDDELAY, obj);
		wx,wy,wz = entity.getPosition(obj);
		sound.play3DSound( AUDIO_ATTACK1, wx,wy,wz);
	end
	
	if(timerID == TIMER_ATTACK1_DAMAGEDELAY)then
		time.stopMultiTimer(TIMER_ATTACK1_DAMAGEDELAY, obj);
		game.doDamage(targetID,0,0,0, attack_Damage,100)
		--doDamage=true
	end
end	

---------------------------------------------------------------------------------
-- SENSOR
---------------------------------------------------------------------------------
function onSensorContact_Enter( targetID )
	if(playerKO==1)then return; end
	action_AttackStart(targetID, 1);
end


function onSensorContact_Exit( targetID )
	if(playerKO==1)then return; end
	anim.playAnimation(obj, CURRENT_ANIM, 30, 0);
	time.stopMultiTimer(TIMER_ATTACK1, obj);
	attacking = 0;
end

function ds_onDamage( health, damage )
	--if(playerKO==1)then return; end
	sky.print("Health: "..health.."  Damage: "..damage,1);
	wx,wy,wz = entity.getPosition(obj);
	sound.play3DSound( AUDIO_SLASHSOUND, wx,wy,wz);
	anim.playAnimation(obj, TAKEHIT_2, 30, 0);
	time.startMultiTimer(TIMER_TAKEHIT_1,obj,400);
end

function ds_onKo()
	if(playerKO==1)then return; end
	wx,wy,wz = entity.getPosition(obj);
	time.stopMultiTimer(TIMER_ATTACK1, obj);
	sound.play3DSound( AUDIO_KO, wx,wy,wz);
	anim.playAnimation(obj, KO_1, 30, 0);
	playerKO = 1;
end


function globalFn( callingID, value )
	if(playerKO==1)then return; end
	if(value=="playerKO" and attacking == 1)then 
		playerKo=true; 
		--anim.playAnimation(obj, CURRENT_ANIM, 30, 0);
		time.stopMultiTimer(TIMER_ATTACK1, obj);
		wx,wy,wz = entity.getPosition(obj);
		sound.play3DSound( AUDIO_HAHA, wx,wy,wz);
		attacking = 0;
		anim.playAnimation(obj, "taunt", 30, 0);
	end
end



