-- |    _____ _          _ _                 _                      ______    _ _ _              
-- |   / ____| |        | (_)               | |                    |  ____|  | (_) |             
-- |  | (___ | | ___   _| |_ _ __   ___     | |    _   _  __ _     | |__   __| |_| |_ ___  _ __  
-- |   \___ \| |/ / | | | | | '_ \ / _ \    | |   | | | |/ _` |    |  __| / _` | | __/ _ \| '__| 
-- |   ____) |   <| |_| | | | | | |  __/    | |___| |_| | (_| |    | |___| (_| | | || (_) | |    
-- |  |_____/|_|\_\\__, |_|_|_| |_|\___|    |______\__,_|\__,_|    |______\__,_|_|\__\___/|_|    
-- |                __/ |                                                                        
-- |               |___/                                                                         

-- |==========================================================================================================================================
-- | Constructors - Automatically Add actions, scripts etc to objects for dynamic use

-- | AI Animal

function entity_main(objID)
	sky.lprint("Generating AI Animal....");
	
	sensorID = action.getActionID(objID, "AI Sensor")
	if(sensorID<=0)then
		sensorID = action.addToEntity(objID,"PLAYER", "AI Sensor");
	else
		sky.lprint("Warning: Adding Action - AI Sensor Action is already active.");
	end
	
	action.setActionParam(objID, sensorID, "AIS Bounds Check Type","1@Closest|All");
	action.setActionParam(objID, sensorID, "AIS Query Data","2");
	action.setActionParam(objID, sensorID, "AIS Bounds Radius","8");

	msID = action.getActionID(objID, "Micro Script")

	--if(msID<=0)then
	--	msID = action.addToEntity(objID,"MISC", "Micro Script");
	--else
	--	sky.lprint("Warning: Adding Action - Micro Script Action is already active.");
	--end

	--action.setActionParam(objID, msID, "Micro Script Data","");

	damageID = action.getActionID(objID, "Damage System")

	if(damageID<=0)then
		damageID = action.addToEntity(objID,"PLAYER", "Damage System");
	else
		sky.lprint("Warning: Adding Action - Damage System Action is already active.");
	end
	
	action.setActionParam(objID, damageID, "DS Health","100");
	action.setActionParam(objID, damageID, "DS Enable KO Effects","false");
	action.setActionParam(objID, damageID, "DS KO Audio Enable","false");

	--entity.addScript(objID,"/Library 0.9.4/Melee_Combat_Dummy.lua");
end

